package de.hhu.ba.yoshikoWrapper.core;

import java.io.File;

import org.slf4j.Logger;

import de.hhu.ba.yoshikoWrapper.logging.YoshikoLogger;

public class YoshikoLoader {
	
	private static boolean isLoaded;
	
	//Symbolic Links
	private static Logger logger = YoshikoLogger.getInstance().getLogger();
	
	public static void loadLibrary(String libPath) {
		
		//Attempt to load from a previously stored path
		File f = new File (libPath);
		if (!f.exists()) {
			logger.info("Could not load the Yoshiko-library from a previously saved path! You might need to set the path manually.");
			return;
		}
		
		try {
			System.out.println("Attempting to load library @: "+libPath);
			System.load(libPath);
			//update cfg
			CyCore.cm.getProperties().setProperty("pathToYoshiko", libPath);
		}
		catch(Exception e) {
			//e.printStackTrace();
			return;
		}
		isLoaded = true;
	}
	
	//SETTER / GETTER

	public static boolean isLibraryLoaded() {
		return isLoaded;
	}

}
