package de.hhu.ba.yoshikoWrapper.gui;

import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JList;

import org.cytoscape.model.CyNode;

import de.hhu.ba.yoshikoWrapper.core.LocalizationManager;

@SuppressWarnings("serial")
public class ClusterView extends ComfortPanel {
	
	private final JLabel title;
	private final JLabel clusterSize;
	
	private JList<String> nodeList;
	
	public ClusterView() {
		this.setLayout(new BoxLayout(this,BoxLayout.Y_AXIS));
		
		this.title = new JLabel("CLUSTERTITLE");
		this.clusterSize = new JLabel("CLUSTERLABEL");
		this.nodeList = new JList<String>();
		
		this.addAll(title,clusterSize,nodeList);
	}
	
	public void setTitle(long x) {
		this.title.setText(LocalizationManager.get("cluster")+" "+x);
		revalidate();
		repaint();
	}

	public void setClusterSize(long x) {
		this.clusterSize.setText(LocalizationManager.get("clusterSize")+" "+x);
		revalidate();
		repaint();
	}

	public void addNode(CyNode node) {
		this.nodeList.add(new JLabel(node.toString()));
		revalidate();
		repaint();
	}
}
